Debian Bug report logs - #709668
libembperl-perl: FTBFS with perl 5.18: test failures

version graph

Package: src:libembperl-perl; Maintainer for src:libembperl-perl is Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>;

Reported by: Dominic Hargreaves <dom@earth.li>

Date: Fri, 24 May 2013 21:45:02 UTC

Severity: serious

Tags: jessie, sid, upstream

Found in version libembperl-perl/2.5.0~rc3-1

Forwarded to https://mail-archives.apache.org/mod_mbox/perl-embperl/201305.mbox/%3C20130525164118.GF831733%40ZEDAT.FU-Berlin.DE%3E

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Fri, 24 May 2013 21:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominic Hargreaves <dom@earth.li>:
New Bug report received and forwarded. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Fri, 24 May 2013 21:45:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Dominic Hargreaves <dom@earth.li>
To: submit@bugs.debian.org
Subject: libembperl-perl: FTBFS with perl 5.18: test failures
Date: Fri, 24 May 2013 22:42:47 +0100
Source: libembperl-perl
Version: 2.5.0~rc3-1
Severity: important
User: debian-perl@lists.debian.org
Usertags: perl-5.18-transition
Tags: sid jessie

This package FTBFS with perl 5.18 from experimental (in a clean sbuild
session):

#51 escape.htm...             
Error in Line 44
Is:     >HashinA<ahref="http://localhost/tests?B=2&amp;A=1"><
Should: >HashinA<ahref="http://localhost/tests?A=1&amp;B=2"><

 ERRORS detected! NOT all tests have been passed successfully

-- 
Dominic Hargreaves | http://www.larted.org.uk/~dom/
PGP key 5178E2A5 from the.earth.li (keyserver,web,email)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Sat, 25 May 2013 16:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Florian Schlichting <fsfs@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sat, 25 May 2013 16:45:04 GMT) Full text and rfc822 format available.

Message #10 received at 709668@bugs.debian.org (full text, mbox):

From: Florian Schlichting <fsfs@debian.org>
To: embperl@perl.apache.org
Cc: 709668@bugs.debian.org
Subject: embperl: test failure with perl 5.18
Date: Sat, 25 May 2013 18:41:18 +0200
Hi Gerald,

Debian is preparing to transition to perl 5.18, and test rebuilds of all
packages have revealed a problem with embperl (tracked at
http://bugs.debian.org/709668):

> This package FTBFS with perl 5.18 from experimental (in a clean sbuild
> session):
> 
> #51 escape.htm...             
> Error in Line 44
> Is:     >HashinA<ahref="http://localhost/tests?B=2&amp;A=1"><
> Should: >HashinA<ahref="http://localhost/tests?A=1&amp;B=2"><
> 
>  ERRORS detected! NOT all tests have been passed successfully

This is potentially due to the Hash overhaul / randomization in perl
5.18 as described at
http://search.cpan.org/dist/perl-5.18.0/pod/perldelta.pod#Hash_overhaul
and may require explicit sorting of keys where their order is relevant.

Will you have time to look into this?

best,
Florian




Added tag(s) upstream. Request was from Florian Schlichting <fsfs@debian.org> to control@bugs.debian.org. (Sat, 25 May 2013 16:48:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Mon, 27 May 2013 03:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerald Richter - ECOS <richter@ecos.de>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Mon, 27 May 2013 03:57:04 GMT) Full text and rfc822 format available.

Message #17 received at 709668@bugs.debian.org (full text, mbox):

From: Gerald Richter - ECOS <richter@ecos.de>
To: Florian Schlichting <fsfs@debian.org>, embperl@perl.apache.org <embperl@perl.apache.org>
Cc: 709668@bugs.debian.org <709668@bugs.debian.org>
Subject: AW: embperl: test failure with perl 5.18
Date: Mon, 27 May 2013 05:49:36 +0200
Hi Florian,

I will take a look at this issue during the next weekend

Gerald


> -----Ursprüngliche Nachricht-----
> Von: Florian Schlichting [mailto:fsfs@debian.org]
> Gesendet: Samstag, 25. Mai 2013 18:41
> An: embperl@perl.apache.org
> Cc: 709668@bugs.debian.org
> Betreff: embperl: test failure with perl 5.18
> 
> Hi Gerald,
> 
> Debian is preparing to transition to perl 5.18, and test rebuilds of all packages
> have revealed a problem with embperl (tracked at
> http://bugs.debian.org/709668):
> 
> > This package FTBFS with perl 5.18 from experimental (in a clean sbuild
> > session):
> >
> > #51 escape.htm...
> > Error in Line 44
> > Is:     >HashinA<ahref="http://localhost/tests?B=2&amp;A=1"><
> > Should: >HashinA<ahref="http://localhost/tests?A=1&amp;B=2"><
> >
> >  ERRORS detected! NOT all tests have been passed successfully
> 
> This is potentially due to the Hash overhaul / randomization in perl
> 5.18 as described at
> http://search.cpan.org/dist/perl-5.18.0/pod/perldelta.pod#Hash_overhaul
> and may require explicit sorting of keys where their order is relevant.
> 
> Will you have time to look into this?
> 
> best,
> Florian
> 
> 
> ---------------------------------------------------------------------
> To unsubscribe, e-mail: embperl-unsubscribe@perl.apache.org
> For additional commands, e-mail: embperl-help@perl.apache.org





Set Bug forwarded-to-address to 'embperl@perl.apache.org <embperl@perl.apache.org>'. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Sun, 09 Jun 2013 14:06:04 GMT) Full text and rfc822 format available.

Added indication that bug 709668 blocks 712615 Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Mon, 17 Jun 2013 22:27:17 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Tue, 16 Jul 2013 04:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerald Richter - ECOS <richter@ecos.de>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 16 Jul 2013 04:54:04 GMT) Full text and rfc822 format available.

Message #26 received at 709668@bugs.debian.org (full text, mbox):

From: Gerald Richter - ECOS <richter@ecos.de>
To: Florian Schlichting <fsfs@debian.org>, embperl@perl.apache.org <embperl@perl.apache.org>
Cc: 709668@bugs.debian.org <709668@bugs.debian.org>
Subject: AW: embperl: test failure with perl 5.18
Date: Tue, 16 Jul 2013 06:44:11 +0200
Hi Florian,

hash randomization and other changes in Perl 5.18 did make things much more complicated than I expected.

I have now a first version that seems to work with Perl 5.18 in the svn.

I have to do some further tests, than I will create a new release

Gerald

> -----Ursprüngliche Nachricht-----
> Von: Florian Schlichting [mailto:fsfs@debian.org]
> Gesendet: Samstag, 25. Mai 2013 18:41
> An: embperl@perl.apache.org
> Cc: 709668@bugs.debian.org
> Betreff: embperl: test failure with perl 5.18
> 
> Hi Gerald,
> 
> Debian is preparing to transition to perl 5.18, and test rebuilds of all packages
> have revealed a problem with embperl (tracked at
> http://bugs.debian.org/709668):
> 
> > This package FTBFS with perl 5.18 from experimental (in a clean sbuild
> > session):
> >
> > #51 escape.htm...
> > Error in Line 44
> > Is:     >HashinA<ahref="http://localhost/tests?B=2&amp;A=1"><
> > Should: >HashinA<ahref="http://localhost/tests?A=1&amp;B=2"><
> >
> >  ERRORS detected! NOT all tests have been passed successfully
> 
> This is potentially due to the Hash overhaul / randomization in perl
> 5.18 as described at
> http://search.cpan.org/dist/perl-5.18.0/pod/perldelta.pod#Hash_overhaul
> and may require explicit sorting of keys where their order is relevant.
> 
> Will you have time to look into this?
> 
> best,
> Florian
> 
> 
> ---------------------------------------------------------------------
> To unsubscribe, e-mail: embperl-unsubscribe@perl.apache.org
> For additional commands, e-mail: embperl-help@perl.apache.org





Changed Bug forwarded-to-address to 'https://mail-archives.apache.org/mod_mbox/perl-embperl/201305.mbox/%3C20130525164118.GF831733%40ZEDAT.FU-Berlin.DE%3E' from 'embperl@perl.apache.org <embperl@perl.apache.org>' Request was from Axel Beckert <abe@debian.org> to control@bugs.debian.org. (Wed, 17 Jul 2013 20:45:08 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from Axel Beckert <abe@debian.org> to control@bugs.debian.org. (Wed, 17 Jul 2013 20:45:09 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'important' Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Tue, 13 Aug 2013 12:21:26 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Fri, 23 Aug 2013 14:48:16 GMT) Full text and rfc822 format available.

Message #35 received at 709668@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: Gerald Richter - ECOS <richter@ecos.de>, 709668@bugs.debian.org
Cc: Florian Schlichting <fsfs@debian.org>, "embperl@perl.apache.org" <embperl@perl.apache.org>
Subject: Re: Bug#709668: AW: embperl: test failure with perl 5.18
Date: Fri, 23 Aug 2013 17:35:51 +0300
Hi, Gerald,

-=| Gerald Richter - ECOS, 16.07.2013 06:44:11 +0200 |=-
> hash randomization and other changes in Perl 5.18 did make things 
> much more complicated than I expected.
> 
> I have now a first version that seems to work with Perl 5.18 in the svn.
> 
> I have to do some further tests, than I will create a new release

I tried to apply the patch from revision 1503556 to the current debian 
sources (version 2.5.0 rc3). The patch applied with only one rejected 
hunk, which I applied by hand.

Embperl built fine and tests that previously failed (51 escape.htm) 
now pass. However, some other tests not fail.

With perl 5.18:

 #32 notfound.htm...           

 Expected 1 more error(s) in logfile

 Input:     test/html/notfound.htm
 Output:        test/tmp/out.htm
 Log:       test/tmp/test.log
 Testparameter:
   errors = 1

and with perl 5.14:

 #247 rtf/rtfadv.asc...        Error in Line 52
 Is:    >{Ulrike}<
 Should:    >{Sarah}<

If the tests pass for you, I guess we could try packaging a snapshot 
from SVN's trunk. 
(https://metacpan.org/module/GRICHTER/Embperl-2.4.0/SVN.pod)

Best regards,
    Damyan,
    Debian Perl Group



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Mon, 26 Aug 2013 06:27:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerald Richter - ECOS <richter@ecos.de>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Mon, 26 Aug 2013 06:27:10 GMT) Full text and rfc822 format available.

Message #40 received at 709668@bugs.debian.org (full text, mbox):

From: Gerald Richter - ECOS <richter@ecos.de>
To: Damyan Ivanov <dmn@debian.org>, 709668@bugs.debian.org <709668@bugs.debian.org>
Cc: Florian Schlichting <fsfs@debian.org>, embperl@perl.apache.org <embperl@perl.apache.org>
Subject: AW: Bug#709668: AW: embperl: test failure with perl 5.18
Date: Mon, 26 Aug 2013 08:13:41 +0200
Hi Damyan and Florian,

thanks for testing and the patches.

I will take a closer look to it during the next few days, create a new tar.gz to make sure nothing is missing and give you a feedback.

Gerald

> -----Ursprüngliche Nachricht-----
> Von: Damyan Ivanov [mailto:dmn@debian.org]
> Gesendet: Freitag, 23. August 2013 16:36
> An: Gerald Richter; 709668@bugs.debian.org
> Cc: Florian Schlichting; embperl@perl.apache.org
> Betreff: Re: Bug#709668: AW: embperl: test failure with perl 5.18
> 
> Hi, Gerald,
> 
> -=| Gerald Richter - ECOS, 16.07.2013 06:44:11 +0200 |=-
> > hash randomization and other changes in Perl 5.18 did make things much
> > more complicated than I expected.
> >
> > I have now a first version that seems to work with Perl 5.18 in the svn.
> >
> > I have to do some further tests, than I will create a new release
> 
> I tried to apply the patch from revision 1503556 to the current debian sources
> (version 2.5.0 rc3). The patch applied with only one rejected hunk, which I
> applied by hand.
> 
> Embperl built fine and tests that previously failed (51 escape.htm) now pass.
> However, some other tests not fail.
> 
> With perl 5.18:
> 
>  #32 notfound.htm...
> 
>  Expected 1 more error(s) in logfile
> 
>  Input:     test/html/notfound.htm
>  Output:        test/tmp/out.htm
>  Log:       test/tmp/test.log
>  Testparameter:
>    errors = 1
> 
> and with perl 5.14:
> 
>  #247 rtf/rtfadv.asc...        Error in Line 52
>  Is:    >{Ulrike}<
>  Should:    >{Sarah}<
> 
> If the tests pass for you, I guess we could try packaging a snapshot from
> SVN's trunk.
> (https://metacpan.org/module/GRICHTER/Embperl-2.4.0/SVN.pod)
> 
> Best regards,
>     Damyan,
>     Debian Perl Group
> 
> ---------------------------------------------------------------------
> To unsubscribe, e-mail: embperl-unsubscribe@perl.apache.org
> For additional commands, e-mail: embperl-help@perl.apache.org





Removed tag(s) fixed-upstream. Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Sat, 31 Aug 2013 09:54:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#709668; Package src:libembperl-perl. (Sun, 26 Jan 2014 01:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sun, 26 Jan 2014 01:18:05 GMT) Full text and rfc822 format available.

Message #47 received at 709668@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: embperl@perl.apache.org
Cc: 709668@bugs.debian.org
Subject: [PARTIAL PATCH] Re: Bug#709668: embperl: test failure with perl 5.18
Date: Sun, 26 Jan 2014 02:14:43 +0100
[Message part 1 (text/plain, inline)]
Hi Gerald,

On Mon, Aug 26, 2013 at 08:13:41AM +0200, Gerald Richter wrote:
> I will take a closer look to it during the next few days, create a
> new tar.gz to make sure nothing is missing and give you a feedback.

I just noticed there's a new Embperl 2.5.0 RC4 and checked how far it
comes with regards to the test suite.

There are still a bunch of hash randomisation issues. I've attached a
patch which fixes all of those I encountered so far by running the
test suite many dozen times. I would expect that you could apply this
patch to your code without changes.

Further I disabled all tests which just check more or less Perl
version specific error messages (i.e. includeerr{2,3}.htm) in our
package build. (But I think that should be solved differently
upstream, if it's an issue for you, too.)

This leaves so far two issues which look like real bugs:

#66 lists.htm fails occassionally and non-deterministically, but it
doesn't seem to be a hash randomisation issue. If it fails, it looks
like this:

#66 lists.htm...              
Error in Line 54
Is:     ></select></p><
Should: ><optionvalue="B"SELECTED>2</option><
Input:          test/html/lists.htm
Output:         test/tmp/out.htm
Compared to:    test/cmp/lists.htm
Log:            test/tmp/test.log
Testparameter:
  query_info = sel=2&SEL1=B&SEL3=D&SEL4=cc

And if I check test/tmp/out.htm vs test/cmp/lists.htm, I see

    <p><select name="D1"  size="1">
        <option value="A" >1</option>
    </select></p>

but should see

    <p><select name="D1"  size="1">
        <option value="A" >1</option>
    
        <option value="B" SELECTED>2</option>
    
        <option value="C" >3</option>
    
        <option value="D" >4</option>
    
        <option value="E" >5</option>
    
        <option value="F" >6</option>
    </select></p>

This does not look like a hash randomisation issue to me and hence may
be a real bug.

If #66 passes, the next one which fails (and always fails) is #147
exit.htm:

#147 exit.htm...              
Error in Line 11
Is:     After Exit
Should: <EOF>
Input:          test/html/exit.htm
Output:         test/tmp/out.htm
Compared to:    test/cmp/exit.htm
Log:            test/tmp/test.log
Testparameter:
  cgi = 0

This looks like a real bug as "[- exit -]" seems to have no effect but
should have an effect.

Hope this helps.

		Regards, Axel
-- 
 ,''`.  |  Axel Beckert <abe@debian.org>, http://people.debian.org/~abe/
: :' :  |  Debian Developer, ftp.ch.debian.org Admin
`. `'   |  1024D: F067 EA27 26B9 C3FC 1486  202E C09E 1D89 9593 0EDE
  `-    |  4096R: 2517 B724 C5F6 CA99 5329  6E61 2FF9 CD59 6126 16B5
[test_suite_issues.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 13:28:50 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.